/*
   -
   - The contents of this file are subject to the Mozilla Public License
   - Version 1.1 (the "License"); you may not use this file except in
   - compliance with the License. You may obtain a copy of the License at
   - http://www.mozilla.org/MPL/ 
   - 
   - Software distributed under the License is distributed on an "AS IS" basis,
   - WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
   - for the specific language governing rights and limitations under the
   - License. 
   -
   - The Original Code is Bugxula
   - 
   - The Initial Developer of the Original Code is
   - Netscape Communications Corporation
   - Portions created by Netscape are
   - Copyright (C) 1998 Netscape Communications Corporation.
   - All Rights Reserved.
   -
   - Alternatively, the contents of this file may be used under the
   - terms of the GNU Public License (the "GPL"), in which case the
   - provisions of the GPL are applicable instead of those above.
   - If you wish to allow use of your version of this file only
   - under the terms of the GPL and not to allow others to use your
   - version of this file under the MPL, indicate your decision by
   - deleting the provisions above and replace them with the notice
   - and other provisions required by the GPL.  If you do not delete
   - the provisions above, a recipient may use your version of this
   - file under either the MPL or the GPL.
   -
   - Contributor(s):
   -  
   - Myk Melez, myk@mozilla.org, original author
   - 
*/

var gDefaultColumnSettings = {};
var gAppConfigDS;

function onLoad()
{
/*
var template = document.getElementById('criterion-template');
var copy = template.cloneNode(true);
var criteria = document.getElementById('criteria');
alert(criteria);
criteria.appendChild(copy);
copy.style.display = "block";
*/

  // Retrieve the user's preferences file, load it as an RDF datasource,
  // and load the user's preferences from it.
  loadPreferencesFile();

  // Load the Bugxula configuration file.
  gAppConfigDS = loadDataSource("chrome://bugxula/content/config.rdf");

  // There's a bug in menulist elements where adding selected="true"
  // to one of their items selects that item but doesn't show that
  // it's selected.  To work around that problem, we select the items
  // explicitly here.
  document.getElementById('search-state').selectedIndex = 1;
  document.getElementById('search-product').selectedIndex = 0;
  document.getElementById('search-field').selectedIndex = 1;
  document.getElementById('search-operator').selectedIndex = 6;

  // Save the current column settings as the default.
  // This way we can reset them to the default when deactivating
  // a search or when activating an unsaved search.
  gDefaultColumnSettings = getColumnSettings();
}

function updateMenus()
{
  updateMenu('search-product', 'bz:products');
  updateMenu('search-field', 'bz:fields');
}

function updateMenu(menuID, rdfAttribute)
{
  // When the user selects a new installation on the Quick Search toolbar,
  // this function updates various menus on that bar whose values depend
  // on the installation being searched (f.e. the product and field menus).
  
  // This might be as simple as changing the value of the each menu's
  // "datasources" attribute, but that approach doesn't work for me
  // (a bug in the connection between that attribute and the database
  // perhaps?), so instead I explicitly remove the old data source
  // from the menu and add the new one to it.
  
  // Remove the old data source from the menu.
  var menu = document.getElementById(menuID);
  if (menu.datasources != "" && menu.datasources != "rdf:null")
  {
    var oldDS = gRDFService.GetDataSource(menu.datasources);
    menu.database.RemoveDataSource(oldDS);
  }
  
  // Get the new data source.
  var installationMenu = document.getElementById('search-installation');
  if (typeof installationMenu.selectedItem == "undefined")
    return;
  var installationURI = installationMenu.selectedItem.value;
  var configurationURI = installationURI + "config.cgi?ctype=rdf";
  var newDS = new RDFDataSource(configurationURI);

  // Add the new data source to the menu if it is loaded and contains values
  // for the menu; otherwise add the global configuration data source
  // (for default values if any).
  if (newDS.loaded() && newDS.getTarget(installationURI, rdfAttribute))
  {
      menu.database.AddDataSource(newDS.ds);
      menu.ref = installationURI;
  }
  else
  {
    //buildFieldsMenu();
    menu.database.AddDataSource(gAppConfigDS.ds);
    menu.ref = "urn:bugxula:root";
    if (!newDS.loaded()) newDS.load(InstallConfigObserver);
  }

  // Select the first item in the menu.
  menu.selectedIndex = 0;
}

/* Another way to build the fields menu without XUL templates.  It works,
 * but it can't work in conjunction with XUL templates when an installation
 * configuration file contains field descriptions, so we have to use one
 * or the other exclusively.

var gFields = [
  { name: 'foobar', description: 'baz' },
  { name: 'bug_id', description: 'Bug #' },
  { name: 'short_desc', description: 'Summary' },
  { name: 'product', description: 'Product' },
  { name: 'version', description: 'Version' },
  { name: 'rep_platform', description: 'Platform' },
  { name: 'bug_file_loc', description: 'URL' },
  { name: 'op_sys', description: 'OS/Version' },
  { name: 'bug_status', description: 'Status' },
  { name: 'status_whiteboard', description: 'Status Whiteboard' },
  { name: 'keywords', description: 'Keywords' },
  { name: 'resolution', description: 'Resolution' },
  { name: 'bug_severity', description: 'Severity' },
  { name: 'priority', description: 'Priority' },
  { name: 'component', description: 'Component' },
  { name: 'assigned_to', description: 'AssignedTo' },
  { name: 'reporter', description: 'ReportedBy' },
  { name: 'votes', description: 'Votes' },
  { name: 'qa_contact', description: 'QAContact' },
  { name: 'cc', description: 'CC' },
  { name: 'dependson', description: 'BugsThisDependsOn' },
  { name: 'blocked', description: 'OtherBugsDependingOnThis' },
  { name: 'attachments.description', description: 'Attachment description' },
  { name: 'attachments.thedata', description: 'Attachment data' },
  { name: 'attachments.filename', description: 'Attachment filename' },
  { name: 'attachments.mimetype', description: 'Attachment mime type' },
  { name: 'attachments.ispatch', description: 'Attachment is patch' },
  { name: 'attachments.isobsolete', description: 'Attachment is obsolete' },
  { name: 'attachments.isprivate', description: 'Attachment is private' },
  { name: 'target_milestone', description: 'Target Milestone' },
  { name: 'delta_ts', description: 'Last changed date' },
  { name: '(to_days(now()) - to_days(bugs.delta_ts))', description: 'Days since bug changed' },
  { name: 'longdesc', description: 'Comment' },
  { name: 'alias', description: 'Alias' },
  { name: 'everconfirmed', description: 'Ever Confirmed' },
  { name: 'reporter_accessible', description: 'Reporter Accessible' },
  { name: 'cclist_accessible', description: 'CC Accessible' },
  { name: 'bug_group', description: 'Group' },
  { name: 'estimated_time', description: 'Estimated Hours' },
  { name: 'flagtypes.name', description: 'Flag' },
  { name: 'requesters.login_name', description: 'Flag Requester' },
  { name: 'setters.login_name', description: 'Flag Setter' },
  { name: 'content', description: 'Content' },
];

function buildFieldsMenu()
{
  var menu = document.getElementById('search-field');
  if (!menu) return;
  var popup = menu.getElementsByTagName("menupopup")[0];
  if (!popup) return;
  for ( var i=0 ; i<gFields.length ; i++ ) {
    var item = document.createElement("menuitem");
    item.setAttribute('value', gFields[i].name);
    item.setAttribute('label', gFields[i].description);
    popup.appendChild(item);
  }
}
*/

function runSavedSearch(event)
{
  // Get the RDF resource representing the search the user wants to run.
  var tree = document.getElementById('searches-tree');
  var index = tree.currentIndex;
  var builder = tree.builder.QueryInterface(Components.interfaces.nsIXULTreeBuilder);
  var search = builder.getResourceAtIndex(tree.currentIndex);
  var uri = search.Value;
  
  dd("running search " + uri);
  
  deactivateSearch();
  activateSearch(uri);

  //gNewActiveSearch = new Query(gUserDS.ds, search);

  // Populate the quick search bar with the conditions of the search.
  populateQuickSearch();
}

function runQuickSearch()
{
  var installation = document.getElementById('search-installation').value;
  var state = document.getElementById('search-state').value;
  var product = document.getElementById('search-product').value;
  
  var field = document.getElementById('search-field').value;
  var operator = document.getElementById('search-operator').value;
  var term = document.getElementById('search-term').value;
  
  // Build a string of search conditions.
  var conditions = "";
  
  if (state == 'unconfirmed')
    conditions += "&bug_status=UNCONFIRMED";
  else if (state == 'open')
    conditions += "&bug_status=NEW&bug_status=ASSIGNED&bug_status=REOPENED";
  else if (state == 'closed')
    conditions += "&bug_status=RESOLVED&bug_status=VERIFIED&bug_status=CLOSED";
  
  if (product)
    conditions += "&product=" + escape(product);
  
  conditions += "&field0-0-0=" + field + "&type0-0-0=" + operator + 
                "&value0-0-0=" + escape(term);
    
  deactivateSearch();
  activateSearch(null, installation, conditions);
}

function showBug()
{
  var bugID = document.getElementById('bug-id').value;
  var installations = document.getElementById('show-installations');
  var installation = installations.value;
  var bugURL = installation + 'show_bug.cgi?id=' + bugID;
  
  loadBug(bugURL, true);
}

function loadBugInContentPane()
{
  // Loads the bug selected in the results pane into Bugxula's content pane 
  // if the pane is visible.
  
  var tree = document.getElementById('results-tree');
  var index = tree.currentIndex;
  var builder = tree.builder.QueryInterface(Components.interfaces.nsIXULTreeBuilder);
  var resource = builder.getResourceAtIndex(index);
  var bugURL = resource.Value;
  
  loadBug(bugURL, false);
}

function loadBugInBrowser()
{
  var tree = document.getElementById('results-tree');
  var index = tree.currentIndex;
  var builder = tree.builder.QueryInterface(Components.interfaces.nsIXULTreeBuilder);
  var resource = builder.getResourceAtIndex(index);
  var bugURL = resource.Value;

  loadURLInBrowser(bugURL);
}

function openAdvancedSearchDialog()
{
  window.openDialog('chrome://bugxula/content/advanced-search.xul', 'Advanced Search', 'chrome,close,titlebar,modal');
}

function saveSearch()
{
  var name = prompt("Please enter a name for the search:");
  
  // Cancel without doing anything if the user clicked the "Cancel" button.
  if (name == undefined) return;
  
  // For some reason the user didn't enter a name but still wants to save
  // the search.  Assume they know what they are doing and assign the search
  // a default name.
  if (name == "") name = "unnamed search";

  // Generate a unique URI for this query.
  // !!! Figure out how to assign an RDF type to the resource so it looks like
  // <bz:query...> in the data source instead of <RDF:Description...>!
  var queryURI = gUserDS.generateUniqueURI();
  
  // Add the query to the user's list of queries.
  var queries = gUserDS.getContainer("urn:bugxula:root", "bz:queries");
  queries.appendResource(queryURI);
  
  // Create a list of installations for the query and add the query's installation to it.
  var installations = gUserDS.makeBag(queryURI, "bz:installations");
  for ( var i=0 ; i<gActiveSearch.installations.length ; i++ )
    installations.appendResource(gActiveSearch.installations[i]);

  // Add the search conditions and give the query a name.
  gUserDS.assertLiteral(queryURI, "bz:conditions", gActiveSearch.conditions);
  gUserDS.assertLiteral(queryURI, "bz:name", name);
  
  activateSearch(queryURI);

  // Save the user's data source to disk to make sure we don't lose this query
  // if Mozilla crashes.
  gUserDS.flush();
}

function editSearch()
{
  alert("Sorry, this feature isn't implemented yet.");
}

function refreshSearch()
{
  var results = getActiveResults();
  var resultURI, ds;
  while (results.hasMoreElements())
  {
    resultURI = results.getNextElement();
    ds = RDFDataSource.get(resultURI);
    if (ds)
    {
      gActiveSearch.state = "loading";
      incrementProgressMeter();
      ds.refresh();
    }
  }
  updateSearchOptions();
}

function deleteSearch()
{
  // Remove the installations list from the search resource and the data source.
  var installations = gUserDS.getContainer(gActiveSearch.uri, 'bz:installations');
  installations.purge();
  
  // Remove the conditions from the search resource.
  var conditions = gUserDS.getTarget(gActiveSearch.uri, 'bz:conditions');
  gUserDS.unassertResource(gActiveSearch.uri, 'bz:conditions', conditions);

  // Remove the search resource from the list of searches.
  var searches = gUserDS.getContainer("urn:bugxula:root", 'bz:queries');
  searches.removeResource(gActiveSearch.uri);

  // Unload the query's results from the results pane.
  deactivateSearch();

  // Rebuild the search pane so the entry for this search disappears.
  document.getElementById('searches-tree').builder.rebuild();
}


function handleContentAreaClick(event)
{
  // Adapted from contentAreaClick() in
  // mozilla/xpfe/communicator/resources/content/contentAreaClick.js.
  
  // That function handles all kinds of clicks except for left-clicks on links, 
  // which it passes back to the browser widget to handle by just returning 
  // "true" in those situations.
  
  // I wish I could use that function instead of rolling my own, but I need 
  // to open left-clicked links in a browser window rather than allowing 
  // the browser widget embedded in this application to handle them.
  // The embedded browser widget shouldn't be handling these links anyway
  // (the one in messenger.xul doesn't handle them), but I can't figure out
  // how to make that happen.
  
  // So, instead I use some code from that function to call handleLinkClick() 
  // (from the same file) on the appropriate URL and note that function's 
  // return value.  If it returns false, meaning it did not handle the link,
  // I handle it myself by opening it in a browser window (creating
  // a new one if necessary) using code I adapted from 
  // mozilla/xpfe/components/search/resources/search-panel.js.

  var target = event.target;
  var linkNode;
  
  var local_name = target.localName;
 
  if (local_name) {
    local_name = local_name.toLowerCase();
  }

  switch (local_name) {
    case "a":
    case "area":
    case "link":
      if (target.hasAttribute("href")) 
        linkNode = target;
      break;
    default:
      linkNode = findParentNode(event.originalTarget, "a");
      // <a> cannot be nested.  So if we find an anchor without an
      // href, there is no useful <a> around the target
      if (linkNode && !linkNode.hasAttribute("href"))
        linkNode = null;
      break;
  }
  if (linkNode) 
  {
    var handled = handleLinkClick(event, linkNode.href);
    if (!handled) loadURLInBrowser(linkNode.href);
  } 
  else 
  {
    // The user did not click on a link, so let the click event continue
    // in case some other handler needs to do something with it.
    return true;
  }

  return false;
}

function stopRun()
{
  // Stops the search currently being run.
  
  // Get a list of active results being loaded.
  var results = getActiveResults();  
  var resultURI, ds;
  while (results.hasMoreElements())
  {
    resultURI = results.getNextElement();
    ds = RDFDataSource.get(resultURI);
    if (ds) ds.cancelLoad();
  }
  
  deactivateSearch();
}

